#! /usr/bin/perl -w
######################################################################################################################
#
# Linux instala?ní script
#
# $Id: linuxinstall-mainpart.pl,v 1.8 2011-09-22 09:11:01 mpetro Exp $
#
######################################################################################################################

use strict;
use File::Path;
use File::Basename;
use File::Copy;
use Getopt::Long;

######################################################################################################################
# Některé konfigura?ní konstanty
######################################################################################################################
my $FILE_EULA = 'EULA.txt';
my $DOWNLOAD_SERVER = "http://dls.photoprintit.com";
my $KEYACCID = '4860';
my $CLIENTID = '38';
my $HPS_VER = '4.6.9';
my $VENDOR_NAME = 'Fotolab';
my $APPLICATION_NAME = 'Fotolab Fotosvet 4';
my $HAS_PHOTOFUN = 'false';
my $HAS_CANVAS = 'false';
my $HAS_POSTER = 'false';
my $HAS_PREMIUMFOTO = 'false';
my $HAS_BUDGETFOTO = 'false';
my $HAS_CALENDARS = 'false';
my $HAS_FOTOBOOKS = 'false';
my $HAS_THEME_DESIGN = 'true';
my $HAS_THEME_DMBABY = 'false';
my $HAS_THEME_ALB = 'true';
my $PROGRAM_NAME_FOTOSHOW = 'CEWE prezentace fotografií';


######################################################################################################################
# Některé konstanty
######################################################################################################################
my $DESKTOP_ICON_NAME = $APPLICATION_NAME.'_'.$HPS_VER.'.desktop';
my $DESKTOP_ICON_PATH = '/Resources/keyaccount/32.xpm';
my $SERVICES_XML_PATH = '/Resources/services.xml';
my $AFFILIATE_ID = '';


######################################################################################################################
# Texty
######################################################################################################################
my @TRANSLATABLE;
my @TRANSLATABLE_ERRORS;


$TRANSLATABLE[0]  = "ano";
$TRANSLATABLE[1]  = "a";
$TRANSLATABLE[2]  = "ne";
$TRANSLATABLE[3]  = "n";
$TRANSLATABLE[4]  = "Tento script Vám pomůže při instalaci'\033[1m%1\$s\033[0m' na Váš po?íta? a provede Vás celým instala?ním procesem krok za krokem. \n\n\n";
$TRANSLATABLE[5]  = "Prosím, pro?těte si pozorně VOP (Všeobecné obchodní podmínky). Následně musíte s VOP souhlasit.\n\tV rámci VOP se můžete pohybovat pomocí kláves šipek. Stisknutím klávesy'\033[1mq\033[0m' opustíte VOP.\n\tDále s <CR>.";
$TRANSLATABLE[6]  = "\tSouhlasíte s VOP? [%1\$s/\033[1m%2\$s\033[0m] ";
$TRANSLATABLE[7]  = "\033[0m\033[1m'%1\$s'\033[0m nelze bohužel na Váš po?íta? instalovat.\n\n\n";
$TRANSLATABLE[8]  = "Kam má být'\033[1m%1\$s\033[0m' instalován? [\033[1m%2\$s\033[0m] ";
$TRANSLATABLE[9]  = "\tChcete pokra?ovat v instalaci a potřebná data stáhnout z internetu?[\033[1m%1\$s\033[0m/%2\$s] ";
$TRANSLATABLE[10] = "\tStahování: '%1\$s'\n";
$TRANSLATABLE[11] = "Potřebné soubory se právě rozbalují v instala?ním adresáři\n";
$TRANSLATABLE[12] = "\nGratulujeme!\nÚspěšne jste na svém po?íta?i instalovali \033[1m'%1\$s'\033[0m.\nPro spuštění rozbalte prosím soubour'%2\$s'.\n\nPříjemnou zábavu!\n";
$TRANSLATABLE[13] = "Chcete se opětovně pokusit stáhnout soubor?[%1\$s/\033[1m%2\$s\033[0m] ";
$TRANSLATABLE[14] = "\t    %1\$-18s %2\$20s %3\$9s (%4\$5s)\n";
$TRANSLATABLE[15] = "\tJeště musí být staženo celkem %1\$.2fMBdat z internetu.\n";
$TRANSLATABLE[16] = "Pro úspěšnou instalaci je nutné stáhnout z internetu ještě následující složky.\n";
$TRANSLATABLE[17] = "Stažené instala?ní balí?ky nebyly po instalaci odstraněny a nachází se v aktuálním adresáři.";
$TRANSLATABLE[18] = "Stažené instala?ní balí?ky nebyly po instalaci odstraněny a byly zkopírovány s tímto instala?ním skriptem na %1\$s.";
$TRANSLATABLE[19] = "Zvolený adresář neexistuje.Má být založen? [\033[1m%1\$s\033[0m/%2\$s] ";
$TRANSLATABLE[20] = "Možnosti příkazového řádku:\n   -h; --help\n   -i; --installDir=<DIR>\tAdresář má být instalován do'%1\$s'.\n   -k; --keepPackages\t\tStažené soubory nebudou smazány a mohou být použity pro další instalaci.\n   -w; --workingDir=<DIR>\tAdresář může být uložen do do?asného souboru.\n   -v; --verbose\t\tPři stahování informuje.\n\n Script vyhledává v aktuálním adresáři instala?ní soubory. Pokud soubory nenalezne tam, budou staženy z internetu.\nDo?asné soubory se uloží do aktuálního adresáře nebo do adresáře zvoleném--workingDir. Pokud to kvůli chybějícím oprávněním není možné, budou do?asné soubory uloženy do /tmp.\n";

$TRANSLATABLE_ERRORS[0]  = "Pro možnosti příkazového řádku '--installDir' a --workingDir' je zadání adresáře bezpodmíne?ně nutné!\n";
$TRANSLATABLE_ERRORS[1]  = "Při updatu je zadání instala?ního adresáře s'--installDir' bezpodmíne?ně nutné!\n";
$TRANSLATABLE_ERRORS[2]  = "Zadaný pracovní adresář'%1\$s' neexistuje!\n";
$TRANSLATABLE_ERRORS[3]  = "Pracovní adresář nebylo možné nalézt!\n";
$TRANSLATABLE_ERRORS[4]  = "Pro správné rozbalení scriptu potřebujete program '%1\$s' \n";
$TRANSLATABLE_ERRORS[5]  = "Soubor'%1\$s' nelze nalézt!\n";
$TRANSLATABLE_ERRORS[6]  = "\tNesouhlasili jste s VOP!\n\t%1\$s";
$TRANSLATABLE_ERRORS[7]  = "V zadaném adresáři není možné ukládat symbolické odkazy.Toto je ale pro instalaci'%1\$s' bezpodmíne?ně nutné!\n";
$TRANSLATABLE_ERRORS[8]  = "Stahování souboru'%1\$s'se nezdařilo!\n";
$TRANSLATABLE_ERRORS[9]  = "Soubor '%1\$s' nelze otevřít!\n";
$TRANSLATABLE_ERRORS[10] = "Platformu nebylo možné nalézt!'uname -m' nedodává ani'i686' ani 'x86_64' ale'%1\$s'.\n";
$TRANSLATABLE_ERRORS[11] = "Soubor'%1\$s' nebylo možné stáhnout!\n";
$TRANSLATABLE_ERRORS[12] = "Adresář'%1\$s' nebylo možné založit.\n";
$TRANSLATABLE_ERRORS[13] = "Soubor%1\$s' nelze rozbalit!\n";
$TRANSLATABLE_ERRORS[14] = "Soubor%1\$s' nebylo možné zkopírovat do '%2\$s'!\n";
$TRANSLATABLE_ERRORS[15] = "Kontrolovaná ?ást staženého souboru'%1\$s' nesouhlasí!\n";
$TRANSLATABLE_ERRORS[16] = "Soubor'%1\$s' nebylo možné do'%2\$s'stáhnout!\n";
$TRANSLATABLE_ERRORS[17] = "Potřebné pakety nebylo možné nalézt!\n";


my @ANSWER_YES_LIST = ($TRANSLATABLE[0], $TRANSLATABLE[1]);
my @ANSWER_NO_LIST  = ($TRANSLATABLE[2], $TRANSLATABLE[3]);


######################################################################################################################
# OD TOHOTO M?STA BY SE NEMĚLO NIC MĚNIT
######################################################################################################################
my $INSTALL_DIR_DEV = "$VENDOR_NAME/$APPLICATION_NAME";
my $INDEX_FILE_PATH_ON_SERVER = "/download/Data/$KEYACCID/hps/$CLIENTID-index-$HPS_VER.txt";
my $LOG_FILE_DIR = '.log';
my @REQUIRED_PROGRAMMS = ("unzip", "md5sum", "less", "wget", "uname");
my $DESKTOP_ICON_FORMAT = "[Desktop Entry]\n".
			  "Comment=\n".
			  "Comment[de]=\n".
			  "Encoding=UTF-8\n".
			  "Exec=\"%s/$APPLICATION_NAME\"\n".
			  "Icon=%s$DESKTOP_ICON_PATH\n".
			  "Path=%s\n".
			  "Name=$APPLICATION_NAME\n".
			  "Name[de]=$APPLICATION_NAME\n".
			  "StartupNotify=true\n".
			  "Terminal=false\n".
			  "TerminalOptions=\n".
			  "Type=Application\n";
my $SERVICES_XML_FORMAT = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<services>
<service name=\"a\">t856EvnDTL56xD5fHQnWrzqVk6Xj3we4xGYHfShPmkqXtCzbI21eqJ57eIHVViAg</service>
<service name=\"b\">SNCxjcl5y86nasXrdmtwTWWbBmFs3j21rZOVvoZT9HleOfGJR7FGgZiXsS623ctV</service>
<service name=\"c\">7iIwPfB9c6TIRuf9SPd7I1j25Pex9atTL9TDepMD6nkAyDliZhvIlJOC2tm9pcyQ</service>
<service name=\"d\">%s</service>
<service name=\"e\">EQBuKJf7pzVIbNXzz19PlwkVpERC5KfsWJbG4cazpn3PFC5Rtz4O3V87KcWfMgxK</service>
<service name=\"f\">8ksOkroMJFn1Es3zVJyzxJggNaXiMuLKBfPLBtCyek1bZBcTy29gaU7nm75ZYIxz</service>
<service name=\"g\">xHuXMWCLmtrwNIBvqVB9BAyPjNpEa9gNuybXU51bKsryDqc2UJxSQXM8yIhbIarq</service>
<service name=\"h\">sKTtqevc5EdBSwi3bZkngwl4NSolB8vFc7kPWeAEB4Y1ySgUIgcjJGxKlOll8c8e</service>
</services>\n";

my $DOWNLOAD_START_URL="http://dls.photoprintit.com/api/feedback/$KEYACCID/hps/<update>downloadstart.$AFFILIATE_ID/linux";
my $DOWNLOAD_COMPLETE_URL="http://dls.photoprintit.com/api/feedback/$KEYACCID/hps/<update>downloadcomplete.$AFFILIATE_ID/linux";
my $INSTALLATION_COMPLETE_URL="http://dls.photoprintit.com/api/feedback/$KEYACCID/hps/<update>installationcomplete.$AFFILIATE_ID/linux";



######################################################################################################################
# Proměnné
######################################################################################################################
my $indexContent;			# Zahrnuje obsah indexového souboru
my @filesToDownload;		# Zahrnuje jména souborů, které musí být staženy 
my @downloadedFiles;		# Zahrnuje jména stažených souborů
my @filesToRemove;			# Zahrnuje jména souborů, které musí být na konci scriptu smazán.
my $fileName;				# Zahrnuje jména souborů ur?ených právě ke zpracování 
my $update;
my $upgrade;
my $installDir="";
my $sourceDir="";
my $changeInstallDir=1;
my $verbose;
my $keepPackages=0;
my $workingDir="";



######################################################################################################################
# Zobrazit krátkou nápovědu
######################################################################################################################
sub showHelp {
	printf ($TRANSLATABLE[4], $APPLICATION_NAME);
	printf ($TRANSLATABLE[20], $APPLICATION_NAME);

	exit(0);
}



######################################################################################################################
# Analýza parametrů příkazového řádku
######################################################################################################################
sub getOptions {
	$update      = 0;
	$upgrade     = 0;
	$verbose     = 0;
	$installDir  = "";
	$workingDir  = "";
	my $showHelp = 0;

	GetOptions("installdir=s" => \$installDir,
			"update" => \$update,
			"upgrade" => \$upgrade,
			"verbose" => \$verbose,
			"help" => \$showHelp,
			"keepPackages" => \$keepPackages,
			"workingdir=s" => \$workingDir) || abort($TRANSLATABLE_ERRORS[0]);

	if($showHelp == 1) {
		showHelp();
	}

	if($upgrade == 1) {
		$update = 1;
	}

	if($update == 1
	   && $installDir eq "") {
		abort($TRANSLATABLE_ERRORS[1]);
	}

	if($installDir ne "") {
		$changeInstallDir=0;
	}
}



######################################################################################################################
# Kontrola pracovního adresáře 
######################################################################################################################
sub checkWorkingDir {
	my $testFileName = "test";
	my $testFilePath = $testFileName;

	if($workingDir ne "") {
		if(!opendir(DIR, $workingDir)) {
			abort($TRANSLATABLE_ERRORS[2], $workingDir);
		} else {
			closedir(DIR);
		}
		$testFilePath = $workingDir."/".$testFileName;
	}

	if(!open(TEST_FILE, ">", $testFilePath)) {
		$workingDir   = "/tmp";
		$testFilePath = $workingDir."/".$testFileName;

		if(!open(TEST_FILE, ">", $testFilePath)) {
			abort($TRANSLATABLE_ERRORS[3]);
		} else {
			close(TEST_FILE);
			unlink($testFilePath);
		}
	} else {
		close(TEST_FILE);
		unlink($testFilePath);
	}
}



######################################################################################################################
# Zkontrolovat, zda jsou k dispozici potřebné programy
######################################################################################################################
sub checkProgramms {
	foreach (@REQUIRED_PROGRAMMS) {
		my $status=system("which $_ > /dev/null 2>&1");

		if(0!=$status) {
			abort($TRANSLATABLE_ERRORS[4], $_);
		}
	}
}



######################################################################################################################
# Zobrazit VOP
######################################################################################################################
sub showEula {
	if($FILE_EULA ne "" && $update==0) {
		if(!open(EULA, "<", $FILE_EULA)) {
			abort($TRANSLATABLE_ERRORS[5], $FILE_EULA);
		}
		close EULA;
		printf($TRANSLATABLE[5]);
		my $answer = <STDIN>;

		system("less $FILE_EULA");

		printf($TRANSLATABLE[6], $TRANSLATABLE[0], uc($TRANSLATABLE[2]));
		chomp($answer = <STDIN>);
		$answer=lc($answer);

		my $found=0;
		foreach(@ANSWER_YES_LIST) {
			if($answer eq $_) {
				$found=1;
				last;
			}
		}

		if(0==$found) {
			abort($TRANSLATABLE_ERRORS[6], sprintf($TRANSLATABLE[7], $APPLICATION_NAME));
		}
	}
}



######################################################################################################################
# Vyžádat si instala?ní adresář 
######################################################################################################################
sub getInstallDir {
	if($update == 0 && $changeInstallDir == 1) {
		while(1) {
			if($> == 0) {
				# Root User
				$installDir="/opt/".$INSTALL_DIR_DEV;
			} else {
				# Normaler Benutzer
				$installDir=$ENV{"HOME"}."/".$INSTALL_DIR_DEV;
			}

			printf($TRANSLATABLE[8], $APPLICATION_NAME, $installDir);
			my $answer = <STDIN>;
			chomp($answer);

			if("" ne $answer) {
				$installDir=$answer;
			}

			# vorne und hinten Leerzeichen abschneiden
			$installDir =~ s/^\s+//;
			$installDir =~ s/\s+$//;

			# Jetzt ersetzen wir noch die Tilde durch das Home-Verzeichnis
			$installDir =~ s/^~/$ENV{"HOME"}/;

			# einen relativen Pfad um den aktuellen Pfad erweitern
			if($installDir =~ m/^[^\/]/) {
				$installDir = $ENV{"PWD"}."/".$installDir;
			}

			my $dirCreated = 0;
			if(! -e $installDir) {
				printf($TRANSLATABLE[19], uc($TRANSLATABLE[0]), $TRANSLATABLE[2]);
				my $createAnswer = <STDIN>;
				chomp($createAnswer);

				my $found=1;
				foreach(@ANSWER_NO_LIST) {
					if($createAnswer eq $_) {
						$found=0;
						last;
					}
				}

				if(1==$found) {
					# Installationsverzeichniss anlegen
					eval { mkpath($installDir."/".$LOG_FILE_DIR) };

					$dirCreated = 1;

					if($@) {
						printf(red($TRANSLATABLE_ERRORS[12]), $installDir);
						next;
					}
				} else {
					next;
				}
			}

			my $symlinkTestFile = $installDir."/symlinks_possible";
			my $symlinks_possible = symlink($symlinkTestFile, $symlinkTestFile);

			if($symlinks_possible) {
				unlink $symlinkTestFile;
				last;
			} else {
				if($dirCreated == 1) {
					rmtree($installDir);
				}
				abort($TRANSLATABLE_ERRORS[7], $APPLICATION_NAME);
			}
		}
	}
}



######################################################################################################################
# Stahnout indexový soubor
######################################################################################################################
sub getIndexFile {
	my $downloaded	= 0;
	my $answer	= 1;

	$fileName	= basename($INDEX_FILE_PATH_ON_SERVER);

	if(! -e $fileName
		|| -s $fileName == 0) {
		# Stahuji indexový soubor z internetu. 

		# Když máme pracovní adresář, napíšeme do něj.
		if($workingDir ne "") {
			$fileName = $workingDir."/".$fileName;
		}

		if(0==$verbose) {
			$answer = system("wget -T 60 -t 1 -q $DOWNLOAD_SERVER$INDEX_FILE_PATH_ON_SERVER -O $fileName");
		} else {
			$answer = system("wget -T 60 -t 1 $DOWNLOAD_SERVER$INDEX_FILE_PATH_ON_SERVER -O $fileName");
		}

		if($answer!=0
			|| -s $fileName == 0) {
			unlink($fileName);
			abort($TRANSLATABLE_ERRORS[8], $DOWNLOAD_SERVER.$INDEX_FILE_PATH_ON_SERVER);
		}

		$downloaded=1;
	}

	if(!open(INDEX, "<", $fileName)) {
		abort($TRANSLATABLE_ERRORS[9], $fileName);
	} else {
		while(<INDEX>) {
			$indexContent.=$_;
		}

		close(INDEX);

		if($downloaded==1 && $keepPackages==0) {
			unlink($fileName);
		}
	}
}



######################################################################################################################
# Kontrola indexového souboru a sběr souborů ur?ených ke stažení 
######################################################################################################################
sub checkIndexFile {
	my $totalSize     = 0;
	my $packageString = "";
	my $machineType   = `uname -m`;

	chomp($machineType);

	if($machineType eq "i686") {
		$machineType = "l";
	} elsif($machineType eq "x86_64") {
		# Pro systém 64Bit zde zanést příp. jinou zkratku. 
		$machineType = "l";
	} else {
		abort($TRANSLATABLE_ERRORS[10], $machineType);
	}

	if(length($indexContent) == 0) {
		abort($TRANSLATABLE_ERRORS[17]);
	}

	foreach (split(/[\r\n]+/, $indexContent)) {
		chomp;
		if(/^(.*);(.*);(.*);(.*)$/) {
			my $filePath = $1;
			my $required = $2;
			my $what     = $3;
			my $system   = $4;

			if($system eq $machineType || $system eq "a") {
				$fileName	= basename($filePath);

				if(! -e $installDir."/".$LOG_FILE_DIR."/".$fileName.".log") {
					# Soubor ještě není instalován.
					if( -e $fileName ) {
						# Soubor je k dispozici v místě, tedy není nutné jej stahovat. 
						push(@downloadedFiles, $fileName);
					} else {
						my $file2get;
						if($filePath =~ m/^http:/) {
						   $file2get = $filePath;
						} else {
						   $file2get = $DOWNLOAD_SERVER."/".$filePath;
						}
						# Soubor musí být stažen ze sítě. Vypišme tedy, kolik je třeba stáhnout. 
						my $spider = `export LANG=C;wget --spider $file2get 2>&1`;
						my ($size, $dummy, $mb, $mime)	= $spider=~/Length:\s+([\d\.,]+)\s+(\(([\d\.,]+[MK]?)\))?\s*(\[.*\])/;
						my $string = sprintf($TRANSLATABLE[14], $what, $mime, $size, $mb);
						$packageString .= $string;
						push(@filesToDownload, $_);
						$size=~s/[\.,]//g;
						$totalSize+=$size;
					}
				}
			}
		}
	}

	if(0!=(scalar @filesToDownload)) {
		printf($TRANSLATABLE[16]);
		printf($packageString);
		printf($TRANSLATABLE[15], $totalSize/(1024*1024));
	}
}



######################################################################################################################
# Roleback
######################################################################################################################
sub roleback {
	my ($fileName) = @_;
	$fileName =~ /^3\d-(.*)_.*$/;
	my $packageName=$1;

	if(opendir(LOG_FILE_DIR, $installDir."/".$LOG_FILE_DIR)) {
		my @allFiles=readdir(LOG_FILE_DIR);
		@allFiles=grep(!/^\./, @allFiles);

		close(LOG_FILE_DIR);

		foreach(@allFiles) {
			$_ =~ /^3\d-(.*)_.*$/;

			if($1 eq $packageName) {
				removePackage($_);
			}
		}
	}
}



######################################################################################################################
#Smazání dat z logfile a logfile samotného 
######################################################################################################################
sub removePackage {
	my ($logFile) = @_;
	my @files;
	my @dirs;

	if(open(LOG_FILE, "<", $installDir."/".$LOG_FILE_DIR."/".$logFile)) {
		while(<LOG_FILE>) {
			if(/^\s*inflating:\s+(.*)/) {
				my $file=$1;
				$file =~ s/^\s+|\s+$//;
				push(@files, $file);
			}
			if(/^\s*creating:\s+(.*)\s*$/) {
				push(@dirs, $1);
			}
		}
		close LOG_FILE;
	}

	# Připojit logfile na seznam souborů ur?ených ke smazání.
	push (@files, $installDir."/".$LOG_FILE_DIR."/".$logFile);

	unlink(@files);

	@dirs = reverse @dirs;
	foreach(@dirs) {
		rmdir $_;
	}
}



######################################################################################################################
# Nahrát všechny soubory z indexového souboru
######################################################################################################################
sub downloadFiles {
	if(0!=(scalar @filesToDownload)) {
		if($update == 0) {
			my $answer;

			printf($TRANSLATABLE[9], uc($TRANSLATABLE[0]), $TRANSLATABLE[2]);

			chomp($answer = <STDIN>);
			$answer=lc($answer);

			foreach(@ANSWER_NO_LIST) {
				if($answer eq $_) {
					exit 1;
					last;
				}
			}
		}

		triggerCountPixel($DOWNLOAD_START_URL);

		# Stahování souborů
		foreach (@filesToDownload) {
			chomp;
			$_ =~ /^(.*);.*;(.*);.*$/;
			my $filePath	= $1;
			my $what	= $2;
			my $error	= 0;
			my $retry	= 1;

			$fileName	= basename($filePath);

			if($workingDir ne "") {
				$fileName = $workingDir."/".$fileName;
			}

			printf($TRANSLATABLE[10], $what);

			while(1==$retry) {
				my $result=1;
				my $file2get;

				if( $filePath =~ m/^http:/) {
				   $file2get=$filePath;
				} else {
				   $file2get = $DOWNLOAD_SERVER."/".$filePath;
				}


				if(0==$verbose) {
					$result=system("wget -q $file2get -O $fileName");
				} else {
					$result=system("wget $file2get -O $fileName");
				}

				if(0==$result) {
					# Extrahuji MD5 položku
					$fileName =~ /^.*_(.*).zip$/;
					my $md5sum=$1;

					# Po?ítám MD5 položku souboru
					$result=`md5sum $fileName`;
					$result =~ /^(\w*)\s+.*$/;
					my $fileMd5sum=$1;

					if($md5sum ne $fileMd5sum) {
						printf(red($TRANSLATABLE_ERRORS[15]), $fileName);
						$error=1;
					} else {
						push(@downloadedFiles, $fileName);
						push(@filesToRemove, $fileName);
						$retry=0;
					}
				} else {
					printf(red($TRANSLATABLE_ERRORS[16]), $file2get, $fileName);
					$error=1;
				}

				if(0==$update && 1==$error) {
					my $answer;
					printf($TRANSLATABLE[13], $TRANSLATABLE[0], uc($TRANSLATABLE[2]));
					chomp($answer = <STDIN>);
					$answer=lc($answer);

					$retry=0;
					foreach(@ANSWER_YES_LIST) {
						if($answer eq $_) {
							$retry=1;
							$error=0;
							last;
						}
					}
				} elsif(1==$update && 1==$error) {
					# Nemáme žádnou konsoli a nemůžeme přijímat žádná zadání. 
					# Proto kon?íme.
					$retry=0;
				}
			}

			if(1==$error) {
				unlink $fileName;
				abort($TRANSLATABLE_ERRORS[11], $fileName);
			}
		}

		triggerCountPixel($DOWNLOAD_COMPLETE_URL);
	}
}



######################################################################################################################
# Kontrola a rozbalení souborů
######################################################################################################################
sub unpackFiles {
	if(0!=(scalar @downloadedFiles)) {
		printf($TRANSLATABLE[11]);

		# Vytvořit instala?ní adresář 
		eval { mkpath($installDir."/".$LOG_FILE_DIR) };

		if($@) {
			abort($TRANSLATABLE_ERRORS[12], $installDir);
		}

		# Rozbalení souboru
		foreach (@downloadedFiles) {
			$fileName     = $_;
			my $fileBaseName = basename($fileName);

			# Zde můžem příp. předchozí instalovanou verzi smazat. 
#Polžky md5 všech stažených dokumentů souhlasí, všechny pakety by tedy měly jít rozbalit. 
			roleback($fileBaseName);

			my $result=0;
			my @unzipReturn;
			@unzipReturn=`unzip -o -d '$installDir' $fileName 2>&1`;

			foreach(@unzipReturn) {
				if(/^\s*error:/) {
					$result=1;
				}
				elsif(/cannot find/) {
					$result=1;
				}
			}

			if(open(OUT, ">", $installDir."/".$LOG_FILE_DIR."/".$fileBaseName.".log")) {
				print OUT  @unzipReturn;
				close(OUT);
			}

			if(0!=$result) {
				abort($TRANSLATABLE_ERRORS[13], $fileName);
			}
		}
	}
}



######################################################################################################################
# Vytvořit Desktop Icons
######################################################################################################################
sub createDesktopIcons {

	if($>==0) {
		#Root User
		my $homeDir="/home/";
		if(opendir(HOME_DIR, $homeDir)) {
			my @allFiles=readdir(HOME_DIR);
			# Vyhodím všechna zadání s te?kou na za?átku 
			@allFiles=grep(!/^\./, @allFiles);

			foreach(@allFiles) {
				# Test, zda se jedná o adresář 
				if(opendir(SUB_DIR, $homeDir.$_)) {
					closedir(SUB_DIR);

					createDesktopIcon($homeDir.$_, $_);
				}
			}
			closedir(HOME_DIR);
		}
	} else {
		# Normální uživatel 
		createDesktopIcon($ENV{"HOME"}, $ENV{"USER"});
	}
}



######################################################################################################################
# Vytvořit Desktop Icon 
######################################################################################################################
sub createDesktopIcon {
	my ($dir, $user) = @_;
	$dir.="/Desktop/";

	if(my ($login, $pass, $uid, $gid) = getpwnam($user)) {
		if(opendir(DIR, $dir)) {
			closedir(DIR);
			if(!open(ICON, ">", $dir.$DESKTOP_ICON_NAME)) {
				abort($TRANSLATABLE_ERRORS[9], $dir.$DESKTOP_ICON_NAME);
			} else {
				printf(ICON $DESKTOP_ICON_FORMAT, $installDir, $installDir, $installDir);
				close(ICON);
			}

			chown $uid, $gid, $dir.$DESKTOP_ICON_NAME;
				# Gnome will das Icon ausführbar haben.
			chmod 0755, $dir.$DESKTOP_ICON_NAME;
		}
	}
}



######################################################################################################################
#Úklid + Dokon?ovací práce
######################################################################################################################
sub cleanup {
	# Odstarňuji instala?ní pakety 
	if($keepPackages==0) {
		unlink(@filesToRemove);
	} else {
		if($workingDir ne "") {
			# Skript a VOP zkopírovat také tam.
			my @installerFiles;
			push(@installerFiles, "install.pl");
			push(@installerFiles, $FILE_EULA);
			push(@installerFiles, basename($INDEX_FILE_PATH_ON_SERVER));

			foreach(@installerFiles) {
				if(!copy($_, $workingDir."/".$_)) {
					printf(TRANSLATABLE_ERRORS[14], $_, $workingDir."/".$_);
				}
			}
			printf($TRANSLATABLE[18], $workingDir);
		} else {
			printf($TRANSLATABLE[17]);
		}
	}

	# Vytvářím Symlinks pro Libs
	if(opendir(INSTALL_DIR, $installDir)) {
		chdir($installDir);
		my @allFiles=readdir(INSTALL_DIR);

		# Vyhazuji všechny záznamy s bodem na za?átku.
		@allFiles=grep(!/^\./, @allFiles);
		my @libFiles=grep(/.+\.so\.\w*/, @allFiles);

		foreach(@libFiles) {
			my $fileName=$_;
			$fileName =~ /(.+\.so)\.(.*)/;
			my $baseFileName=$1;
			my $version=$2;

			my @v = split(/\./, $version);

			unlink($baseFileName);
			symlink($fileName, $baseFileName);
			foreach(@v) {
				$baseFileName.=".".$_;
				if($baseFileName ne $fileName) {
					unlink($baseFileName);
					symlink($fileName, $baseFileName);
				}
			}
		}

		# Měním práva souboru.
		my @binarys;
		push(@binarys, $APPLICATION_NAME);
		push(@binarys, $PROGRAM_NAME_FOTOSHOW);
		push(@binarys, "assistant");
		push(@binarys, "facedetection");
		chmod 0755, @binarys;

		closedir(INSTALL_DIR);
	}

	if($AFFILIATE_ID ne '') {
		if(open(SERVICESXML, ">", $installDir.$SERVICES_XML_PATH)) {
			printf SERVICESXML $SERVICES_XML_FORMAT, $AFFILIATE_ID;
			close(SERVICESXML);
		}
	}
}



######################################################################################################################
# Vyvolat ?íselný pixel URL a smazat soubory, které při tom byly staženy.
######################################################################################################################
sub triggerCountPixel {
	my $pixelFile = "pixel";

	if($upgrade == 1) {
		$_[0] =~ s/<update>/genericupgrade/;
	} elsif($update == 1) {
		$_[0] =~ s/<update>/update/;
	} else {
		$_[0] =~ s/<update>//;
	}

	if($workingDir ne "") {
		$pixelFile = $workingDir."/".$pixelFile;
	}

	system("wget -q $_[0] -O $pixelFile");
	unlink $pixelFile
}



######################################################################################################################
# Podat hlášení o chybě
######################################################################################################################
#sub printErrorMessage {
#	my ($message) = @_;
#
#	print "\033[31m".$message."\033[0m";
#}



######################################################################################################################
# Hláška ?erveně
######################################################################################################################
sub red {
	my $message = $_[0];
	my $retVal  = sprintf("\033[31m%s\033[0m", $message);

	return $retVal;
}



######################################################################################################################
# Hlášení o chybě podat a ukon?it.
######################################################################################################################
sub abort {
	my $message = shift(@_);

	printf(red($message), @_);

	exit 1;
}



######################################################################################################################
# Nahrát překlad
######################################################################################################################
sub loadTranslations {
	if(open(TRANSLATIONS, "<", "install-linux-translations.pl")) {
		my $translationCode;

		while(<TRANSLATIONS>) {
			$translationCode.=$_;
		}

		close(TRANSLATIONS);

		eval($translationCode);

		@ANSWER_YES_LIST = ($TRANSLATABLE[0], $TRANSLATABLE[1]);
		@ANSWER_NO_LIST  = ($TRANSLATABLE[2], $TRANSLATABLE[3]);
	}
}

######################################################################################################################
# Přeložit
######################################################################################################################
#sub translate {
#	my message = $_[0];
#
#	return message;
#}



######################################################################################################################
# MAIN
######################################################################################################################
# Nutně vyprázdnit vyrovnávací paměť po každé print()-operaci.
$| = 1;

system("clear");

loadTranslations();

getOptions();

printf($TRANSLATABLE[4], $APPLICATION_NAME);

checkWorkingDir();

checkProgramms();

showEula();

getInstallDir();

getIndexFile();

checkIndexFile();

downloadFiles();

unpackFiles();

cleanup();

createDesktopIcons();

triggerCountPixel($INSTALLATION_COMPLETE_URL);

printf($TRANSLATABLE[12], $APPLICATION_NAME, $installDir."/".$APPLICATION_NAME);

